// Copyright 2025 Lyderic Maillet (@lydux)
// SPDX-License-Identifier: GPL-2.0-or-later

#pragma once

#define EE_HANDS

#define RP2040_BOOTLOADER_DOUBLE_TAP_RESET
#define RP2040_BOOTLOADER_DOUBLE_TAP_RESET_TIMEOUT 1000U

#define SERIAL_USART_FULL_DUPLEX
#define SERIAL_USART_TX_PIN GP0
#define SERIAL_USART_RX_PIN GP1

/* key matrix size */
#define MATRIX_ROWS 12
#define MATRIX_COLS 6
//#define MATRIX_MUX_COLS 3

// Left side
#define MATRIX_ROW_PINS { GP10, GP11, GP12, GP13, GP14, GP15 }
#define MATRIX_COL_PINS { GP16, GP17, GP18, GP19, GP20, GP21 }
#define ENCODER_A_PINS {}
#define ENCODER_B_PINS {}

//Right side
#define MATRIX_ROW_PINS_RIGHT { GP23, GP29, GP28, GP27, GP26, GP22 }
#define MATRIX_COL_PINS_RIGHT { GP21, GP20, GP19, GP18, GP17, GP16 }
#define ENCODER_A_PINS_RIGHT { GP10 }
#define ENCODER_B_PINS_RIGHT { GP11 }

#define OLED_DISPLAY_128x32
#define OLED_IC OLED_IC_SH1106

/* OLED SPI Pins */
#define OLED_DC_PIN GP6
#define OLED_CS_PIN GP5
#define OLED_RST_PIN GP7

/* Divisor for OLED */
#define OLED_SPI_DIVISOR 4

/* ChibiOS SPI definitions */
#define SPI_DRIVER SPID0
#define SPI_SCK_PIN GP2
#define SPI_MOSI_PIN GP3
#define SPI_MISO_PIN GP4


#define PMW33XX_CS_PIN GP8
#define PMW33XX_CS_DIVISOR 64

//#define PMW33XX_LIFTOFF_DISTANCE 0x02
#define PMW33XX_CPI 800
#define ROTATIONAL_TRANSFORM_ANGLE 0x30
#define POINTING_DEVICE_INVERT_Y
