// Copyright 2022 Ethan (@rocketstrong)
// SPDX-License-Identifier: GPL-2.0-or-later

#include QMK_KEYBOARD_H

/*
 *    ┌──┐┌──┐┌──┐┌──┐┌──┐                ┌──┐┌──┐┌──┐┌──┐┌──┐
 *┌──┐│  ││  ││  ││  ││  │                │  ││  ││  ││  ││  │┌──┐
 *│  │└──┘└──┘└──┘└──┘└──┘                └──┘└──┘└──┘└──┘└──┘│  │
 *└──┘┌──┐┌──┐┌──┐┌──┐┌──┐                ┌──┐┌──┐┌──┐┌──┐┌──┐└──┘
 *┌──┐│  ││  ││  ││  ││  │                │  ││  ││  ││  ││  │┌──┐
 *│  │└──┘└──┘└──┘└──┘└──┘                └──┘└──┘└──┘└──┘└──┘│  │
 *└──┘┌──┐┌──┐┌──┐┌──┐┌──┐                ┌──┐┌──┐┌──┐┌──┐┌──┐└──┘
 *┌──┐│  ││  ││  ││  ││  │                │  ││  ││  ││  ││  │┌──┐
 *│  │└──┘└──┘└──┘└──┘└──┘                └──┘└──┘└──┘└──┘└──┘│  │
 *└──┘┌──┐┌──┐┌──┐┌──┐┌──┐                ┌──┐┌──┐┌──┐┌──┐┌──┐└──┘
 *┌──┐│  ││  ││  ││  ││  │                │  ││  ││  ││  ││  │┌──┐
 *│  │└──┘└──┘└──┘└──┘└──┘                └──┘└──┘└──┘└──┘└──┘│  │
 *└──┘    ┌──┐┌──┐                                ┌──┐┌──┐    └──┘
 *        │  ││  │                                │  ││  │
 *        └──┘└──┘  ┌──┐ ┌──┐          ┌──┐ ┌──┐  └──┘└──┘
 *                  │  │ │  │          │  │ │  │          
 *                  └──┘ └──┘          └──┘ └──┘
 *                    ┌──┐ ┌──┐       ┌──┐ ┌──┐     
 *                    │  │ │  │       │  │ │  │
 *                    └──┘ └──┘       └──┘ └──┘
 *                     ┌──┐┌──┐       ┌──┐┌──┐
 *                     │  ││  │       │  ││  │
 *                     └──┘└──┘       └──┘└──┘
 */

enum custom_keycodes {
    DRAG_SCROLL = SAFE_RANGE,
};

const uint16_t PROGMEM keymaps[][MATRIX_ROWS][MATRIX_COLS] = {
    [0] = LAYOUT(
        KC_ESC , KC_1  , KC_2  , KC_3  , KC_4  , KC_5  ,                         KC_6   , KC_7  , KC_8   ,KC_9  ,KC_0   ,KC_GRV ,
        KC_TAB , KC_Q  , KC_W  , KC_E  , KC_R  , KC_T  ,                         KC_Y   , KC_U  , KC_I   ,KC_O  ,KC_P   ,KC_BSLS,
        KC_LSFT, KC_A  , KC_S  , KC_D  , KC_F  , KC_G  ,                         KC_H   , KC_J  , KC_K   ,KC_L  ,KC_SCLN,KC_QUOT,
        KC_LCTL, KC_Z  , KC_X  , KC_C  , KC_V  , KC_B  ,                         KC_N   , KC_M  , KC_COMM,KC_DOT,KC_SLSH,TG(5)  ,
                        KC_LBRC,KC_RBRC,                                                          KC_MINS,KC_EQL,
                                        KC_LGUI,KC_SPC ,                         KC_ENT , MO(1) ,
                                        MO(3)  ,KC_HOME,                         KC_END , KC_DEL,
                                        KC_BSPC,MO(4)  ,                         MO(2)  , KC_LALT
    ),
    [1] = LAYOUT(
        KC_F12 , KC_F1 , KC_F2 , KC_F3 , KC_F4 , KC_F5 ,                         KC_F6  , KC_F7 , KC_F8 , KC_F9 , KC_F10, KC_F11,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,KC_PGUP,
        KC_TRNS,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,KC_UP  ,KC_PGDN,
        KC_TRNS,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,KC_DOWN,KC_RGHT,
                        _______,_______,                                                         _______,KC_LEFT,
                                        KC_TRNS,_______,                         _______,KC_TRNS,
                                        _______,KC_INS ,                         _______,_______,
                                        _______,_______,                         _______,KC_RALT
    ),
    [2] = LAYOUT(
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
                        _______,_______,                                                         _______,_______,
                                        KC_TRNS,_______,                         _______,_______,
                                        _______,_______,                         _______,_______,
                                        _______,_______,                         KC_TRNS,_______
    ),
    [3] = LAYOUT(
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
                        _______,_______,                                                         _______,_______,
                                        _______,_______,                         _______,_______,
                                        KC_TRNS,_______,                         _______,_______,
                                        _______,_______,                         _______,_______
    ),
    [4] = LAYOUT(
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,QK_BOOT,
                        _______,_______,                                                         _______,_______,
                                        _______,_______,                         _______,_______,
                                        _______,_______,                         _______,_______,
                                        _______,KC_TRNS,                         _______,_______
    ),
    [5] = LAYOUT(
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,_______,
        _______,_______,_______,_______,_______,_______,                         _______,_______,_______,_______,_______,KC_TRNS,
                        _______,_______,                                                         _______,_______,
                                        _______,_______,                         _______,_______,
                                        _______,_______,                         MS_BTN2,_______,
                                        _______,_______,                         MS_BTN1,DRAG_SCROLL
    )
};

#if defined(ENCODER_MAP_ENABLE)
const uint16_t PROGMEM encoder_map[][NUM_ENCODERS][NUM_DIRECTIONS] = {
    [0] = { ENCODER_CCW_CW(MS_WHLU, MS_WHLD) },
    [1] = { ENCODER_CCW_CW(KC_VOLD, KC_VOLU) },
    [2] = { ENCODER_CCW_CW(MS_WHLU, MS_WHLD) },
    [3] = { ENCODER_CCW_CW(MS_WHLU, MS_WHLD) },
    [4] = { ENCODER_CCW_CW(MS_WHLU, MS_WHLD) },
    [5] = { ENCODER_CCW_CW(MS_WHLU, MS_WHLD) },
};
#endif

static void render_logo(void) {
    static const char PROGMEM qmk_logo[] = {
        0x80, 0x81, 0x82, 0x83, 0x84, 0x85, 0x86, 0x87, 0x88, 0x89, 0x8A, 0x8B, 0x8C, 0x8D, 0x8E, 0x8F, 0x90, 0x91, 0x92, 0x93, 0x94,
        0xA0, 0xA1, 0xA2, 0xA3, 0xA4, 0xA5, 0xA6, 0xA7, 0xA8, 0xA9, 0xAA, 0xAB, 0xAC, 0xAD, 0xAE, 0xAF, 0xB0, 0xB1, 0xB2, 0xB3, 0xB4,
        0xC0, 0xC1, 0xC2, 0xC3, 0xC4, 0xC5, 0xC6, 0xC7, 0xC8, 0xC9, 0xCA, 0xCB, 0xCC, 0xCD, 0xCE, 0xCF, 0xD0, 0xD1, 0xD2, 0xD3, 0xD4, 0x00
    };

    oled_write_P(qmk_logo, false);
}

bool oled_task_user(void) {
    render_logo();
    return false;
}


bool set_scrolling = false;
float scroll_accumulated_h = 0;
float scroll_accumulated_v = 0;

#define DRAGSCROLL_DIVISOR_H 16.0
#define DRAGSCROLL_DIVISOR_V 16.0

report_mouse_t pointing_device_task_user(report_mouse_t mouse_report) {
    if (set_scrolling) {
        scroll_accumulated_h += (float)mouse_report.x / DRAGSCROLL_DIVISOR_H;
        scroll_accumulated_v += (float)mouse_report.y / DRAGSCROLL_DIVISOR_V;

        // Assign integer parts of accumulated scroll values to the mouse report
        mouse_report.h = (int8_t)scroll_accumulated_h;
        mouse_report.v = -(int8_t)scroll_accumulated_v;

        // Update accumulated scroll values by subtracting the integer parts
        scroll_accumulated_h -= (int8_t)scroll_accumulated_h;
        scroll_accumulated_v -= (int8_t)scroll_accumulated_v;

        // Clear the X and Y values of the mouse report
        mouse_report.x = 0;
        mouse_report.y = 0;
    }
    return mouse_report;
}

bool process_record_user(uint16_t keycode, keyrecord_t *record) {
    if (keycode == DRAG_SCROLL && record->event.pressed) {
        set_scrolling = !set_scrolling;
    }
    return true;
}
